*-- DEFINE from winuser.h for theme changes
#define WM_THEMECHANGED 0x031A

*-- For getting the address of the VFP window
*-- process
#define GWL_WNDPROC -4

PUBLIC oHandler

*-- Create the object that will be handling this
*-- Windows message
oHandler=CREATEOBJECT("IDEHandler")

*-- Bind to the Windows message 
*-- using new BINDEVENT syntax
BINDEVENT(_screen.hWnd, WM_THEMECHANGED, ;
  oHandler, "HandleEvent")

DEFINE CLASS IDEHandler AS Custom

*-- Placeholder for the VFP window process
nOldProc = 0

PROCEDURE Destroy
  UNBINDEVENT(_SCREEN.hWnd, WM_THEMECHANGED)
ENDPROC

PROCEDURE Init

  *-- Use this API to get the address
  *-- of VFP window process.  Refer to
  *-- MSDN for usage.
  DECLARE integer GetWindowLong IN WIN32API ;
    integer hWnd, ;
    integer nIndex

  *-- Use this API call to pass the message and 
  *-- parameters to the VFP window process
  *-- after we are done with it.
  DECLARE integer CallWindowProc IN WIN32API ;
    integer lpPrevWndFunc, ;
    integer hWnd,integer Msg,;
    integer wParam,;
    integer lParam

  *-- Get the address for the VFP window process 
  *-- to use later.
  *--
  *-- From MSDN, when GetWindowLong is passed 
  *-- GWL_WNDPROC: "Retrieves the address of the 
  *-- window procedure, or a handle representing
  *-- the address of the window procedure."
  THIS.nOldProc=GetWindowLong(_VFP.HWnd,GWL_WNDPROC)
ENDPROC

PROCEDURE HandleEvent(hWnd as Integer, ;
  Msg as Integer, wParam as Integer, lParam as Integer)
  lResult=0

  *-- Note: for WM_THEMECHANGED, MSDN indicates the 
  *-- wParam and lParam are reserved so can't use them.
  DO CASE
    CASE msg= WM_THEMECHANGED
      MESSAGEBOX("Theme Changed!")
    ENDCASE 
     
  *-- Pass the message to the VFP window process
  lResult=CallWindowProc(this.nOldProc, ;
    hWnd,msg,wParam,lParam)
  RETURN lResult
ENDPROC
